import CronCore from '@vue-js-cron/core';

//

var script = {
    name: "VueCronEditor",
    components:{
        'CronCore': CronCore.component,
    },
    props: {
        value: {
            type: String,
            default: '* * * * *'
        }
    }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

/* script */
const __vue_script__ = script;
/* template */
var __vue_render__ = function () {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("CronCore", {
    attrs: { value: _vm.value },
    on: {
      input: function ($event) {
        return _vm.$emit("input", $event)
      },
      error: function ($event) {
        return _vm.$emit("error", $event)
      },
    },
    scopedSlots: _vm._u([
      {
        key: "default",
        fn: function (ref) {
          var fields = ref.fields;
          var period = ref.period;
          return [
            _c(
              "v-row",
              { attrs: { align: "baseline", dense: "" } },
              [
                period.prefix
                  ? _c("v-col", { staticClass: "flex-grow-0" }, [
                      _vm._v(_vm._s(period.prefix)),
                    ])
                  : _vm._e(),
                _vm._v(" "),
                _c(
                  "v-col",
                  { attrs: { cols: "auto" } },
                  [
                    _c(
                      "v-select",
                      _vm._b(
                        {
                          staticClass: "fit",
                          attrs: {
                            items: period.items,
                            "return-object": "",
                            dense: "",
                          },
                          on: { input: period.events.input },
                        },
                        "v-select",
                        period.attrs,
                        false
                      )
                    ),
                  ],
                  1
                ),
                _vm._v(" "),
                period.suffix
                  ? _c("v-col", { staticClass: "flex-grow-0" }, [
                      _vm._v(_vm._s(period.suffix)),
                    ])
                  : _vm._e(),
                _vm._v(" "),
                _vm._l(fields, function (f) {
                  return [
                    f.prefix
                      ? _c(
                          "v-col",
                          { key: f.id + "-prefix", staticClass: "flex-grow-0" },
                          [_vm._v(_vm._s(f.prefix))]
                        )
                      : _vm._e(),
                    _vm._v(" "),
                    _c(
                      "v-col",
                      { key: f.id, attrs: { cols: "auto" } },
                      [
                        _c(
                          "v-select",
                          _vm._g(
                            _vm._b(
                              {
                                staticClass: "fit",
                                attrs: {
                                  items: f.items,
                                  multiple: "",
                                  dense: "",
                                  "menu-props": { auto: false, offsetY: true },
                                },
                                scopedSlots: _vm._u(
                                  [
                                    {
                                      key: "prepend-inner",
                                      fn: function () {
                                        return [
                                          _c("div", [
                                            _vm._v(_vm._s(f.selectedStr)),
                                          ]),
                                        ]
                                      },
                                      proxy: true,
                                    },
                                    {
                                      key: "selection",
                                      fn: function () {
                                        return undefined
                                      },
                                      proxy: true,
                                    },
                                    {
                                      key: "item",
                                      fn: function (ref) {
                                        var item = ref.item;
                                        var attrs = ref.attrs;
                                        var on = ref.on;
                                        return [
                                          _c(
                                            "div",
                                            _vm._g(
                                              _vm._b({}, "div", attrs, false),
                                              on
                                            ),
                                            [_vm._v(_vm._s(item.text))]
                                          ),
                                        ]
                                      },
                                    },
                                  ],
                                  null,
                                  true
                                ),
                              },
                              "v-select",
                              f.attrs,
                              false
                            ),
                            f.events
                          )
                        ),
                      ],
                      1
                    ),
                    _vm._v(" "),
                    f.suffix
                      ? _c(
                          "v-col",
                          { key: f.id + "-suffix", staticClass: "flex-grow-0" },
                          [_vm._v(_vm._s(f.suffix))]
                        )
                      : _vm._e(),
                  ]
                }),
              ],
              2
            ),
          ]
        },
      },
    ]),
  })
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );

// Import vue component

// Declare install function executed by Vue.use()
function install(Vue) {
	if (install.installed) return;
	install.installed = true;
	Vue.component('CronVuetify', __vue_component__);
}

// Create module definition for Vue.use()
const plugin = {
	install,
	component: __vue_component__,
	util: CronCore.util
};

export { plugin as default, install };
